package org.zeroturnaround.javarebel.integration;

import java.lang.reflect.Field;

import java.beans.Introspector;
import org.zeroturnaround.javarebel.ClassEventListener;

public class IntegrationClassEventListener implements ClassEventListener {
  public void onClassEvent(int eventType, Class klass) {
    if (eventType == ClassEventListener.EVENT_LOADED)
      return;

    //Flush JavaBeans reflection cache
    Introspector.flushFromCaches(klass);

    //Reset Groovy callsite caching
    try {
      klass.getDeclaredField("$callSiteArray").set(null, null);
    } catch (NoSuchFieldException e) {
    } catch (IllegalAccessException e) {
    } catch (SecurityException e) {
    }
    
    // Flush enum cache
    if ((klass.getModifiers() & 0x00004000) != 0) {
      try {
        Field f = Class.class.getDeclaredField("enumConstantDirectory");
        f.setAccessible(true);
        f.set(klass, null);
        
        f = Class.class.getDeclaredField("enumConstants");
        f.setAccessible(true);
        f.set(klass, null);
      } catch (NoSuchFieldException e) {
      } catch (IllegalAccessException e) {
      } catch (SecurityException e) {
      }
    }
  }
  
  public int priority() {
    return PRIORITY_CORE + 1000;
  }
}
