package org.zeroturnaround.javarebel.integration.google;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Processes
 * <code>com.google.appengine.tools.development.DevAppServerClassLoader</code>
 * and <code>com.google.appengine.tools.development.IsolatedAppClassLoader</code>.
 * 
 * @author Rein Raudjärv
 */
public class RestrictedUrlClassLoaderCBP extends JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel");
    cp.importPackage("org.zeroturnaround.javarebel.integration.generic");
    
    CtConstructor[] constructors = ctClass.getConstructors();
    for (int i = 0; i < constructors.length; i++)
      constructors[i].insertAfter(
          "{" +
          "  IntegrationFactory.getInstance().registerClassLoader($0, new RestrictedClassResourceSource($0));" +
          "}");
  }
}
